diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/JournalDefaultCacheStrategy.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/JournalDefaultCacheStrategy.java
index de1f6f9b6f..44a30a7bbc 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/JournalDefaultCacheStrategy.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/JournalDefaultCacheStrategy.java
@@ -11,6 +11,7 @@ package eu.etaxonomy.cdm.strategy.cache.reference;
 
 import java.util.UUID;
 
+import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
@@ -22,7 +23,6 @@ import eu.etaxonomy.cdm.strategy.StrategyBase;
 /**
  * @author a.mueller
  * @created 29.06.2008
- * @version 1.0
  */
 public class JournalDefaultCacheStrategy<T extends Reference> extends StrategyBase implements IReferenceBaseCacheStrategy<T> {
 	@SuppressWarnings("unused")
@@ -33,9 +33,9 @@ public class JournalDefaultCacheStrategy<T extends Reference> extends StrategyBa
 	protected String afterYear = "";
 	protected String afterAuthor = ", ";
 
-	private String blank = " ";
-	private String comma = ",";
-	private String dot =".";
+//	private String blank = " ";
+//	private String comma = ",";
+//	private String dot =".";
 	
 	final static UUID uuid = UUID.fromString("c84846cd-c862-462e-81b8-53cf4100ed32");
 	
@@ -63,18 +63,29 @@ public class JournalDefaultCacheStrategy<T extends Reference> extends StrategyBa
 		super();
 	}
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.strategy.cache.common.IIdentifiableEntityCacheStrategy#getTitleCache(eu.etaxonomy.cdm.model.common.IdentifiableEntity)
-	 */
+
+	@Override
 	public String getTitleCache(T journal) {
-		String result = "";
+		return getTitleCache(journal, false);
+		
+
+	}
+	
+
+	@Override
+	public String getAbbrevTitleCache(T journal) {
+		return getTitleCache(journal, true);
+	}
+	
+	
+	private String getTitleCache(T journal, boolean isAbbrev){
 		if (journal == null){
 			return null;
 		}
-		String title = CdmUtils.Nz(journal.getTitle()).trim();
-		if (!"".equals(title) ){
-			result += title;
-		}
+
+		String title = CdmUtils.getPreferredNonEmptyString(journal.getTitle(), journal.getAbbrevTitle(), isAbbrev, true);
+		
+		String result = title;
 		
 //		//delete .
 //		while (result.endsWith(".")){
@@ -82,13 +93,18 @@ public class JournalDefaultCacheStrategy<T extends Reference> extends StrategyBa
 //		}
 		
 //		result = addYear(result, journal);
+		
+		
 		TeamOrPersonBase<?> team = journal.getAuthorTeam();
-		String author = (team == null ? "" : CdmUtils.Nz(team.getTitleCache()));
-		if (! author.equals("")){
-			result = author + afterAuthor + result;
+		if (team != null){
+			String author = CdmUtils.getPreferredNonEmptyString(team.getTitleCache(), team.getNomenclaturalTitle(), isAbbrev, true);
+			if (StringUtils.isNotBlank(author)){
+				result = author + afterAuthor + result;
+			}
 		}
 		return result;
 	}
+
 	
 	public String getCitation(T referenceBase) {
 		StringBuilder stringBuilder = new StringBuilder();
@@ -106,4 +122,6 @@ public class JournalDefaultCacheStrategy<T extends Reference> extends StrategyBa
 		
 		return stringBuilder.toString();
 	}
+
+
 }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/NomRefDefaultCacheStrategyBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/NomRefDefaultCacheStrategyBase.java
index 87e9ba6ffc..1a1739b3ef 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/NomRefDefaultCacheStrategyBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/NomRefDefaultCacheStrategyBase.java
@@ -34,33 +34,49 @@ public abstract class NomRefDefaultCacheStrategyBase<T extends Reference> extend
 	protected String afterYear = "";
 	protected String afterAuthor = ", ";	
 	
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.strategy.cache.reference.INomenclaturalReferenceCacheStrategy#getTokenizedNomenclaturalTitel(eu.etaxonomy.cdm.model.reference.INomenclaturalReference)
-	 */
-	public String getTokenizedNomenclaturalTitel(T nomenclaturalReference) {
-		String result =  getNomRefTitleWithoutYearAndAuthor(nomenclaturalReference);
+
+	@Override
+	public String getTokenizedNomenclaturalTitel(T ref) {
+		String result =  getTitleWithoutYearAndAuthor(ref, true);
 		result += INomenclaturalReference.MICRO_REFERENCE_TOKEN;
-		result = addYear(result, nomenclaturalReference, true);
+		result = addYear(result, ref, true);
 		return result;
 	}
 
-	/* (non-Javadoc)
-	 * @see eu.etaxonomy.cdm.strategy.cache.reference.INomenclaturalReferenceCacheStrategy#getTitleCache(eu.etaxonomy.cdm.model.reference.INomenclaturalReference)
-	 */
+	@Override
 	public String getTitleCache(T nomenclaturalReference) {
+		return getTitleCache(nomenclaturalReference, false);
+	}
+
+	@Override
+	public String getAbbrevTitleCache(T nomenclaturalReference) {
+		return getTitleCache(nomenclaturalReference, true);
+	}
+	
+	private String getTitleCache(T ref, boolean isAbbrev) {
 		//TODO needed?
-		if (nomenclaturalReference.isProtectedTitleCache()){
-			return nomenclaturalReference.getTitleCache();
+		if (isAbbrev && ref.isProtectedAbbrevTitleCache()){
+			return ref.getAbbrevTitleCache();
+		}else if (!isAbbrev && ref.isProtectedTitleCache()){
+			return ref.getTitleCache();
 		}
-		String result =  getNomRefTitleWithoutYearAndAuthor(nomenclaturalReference);
-		result = addYear(result, nomenclaturalReference, false);
-		TeamOrPersonBase<?> team = nomenclaturalReference.getAuthorTeam();
-		if (team != null &&  StringUtils.isNotEmpty(team.getTitleCache()) ){
-			result = team.getTitleCache() + afterAuthor + result;
+		String result =  getTitleWithoutYearAndAuthor(ref, isAbbrev);
+		result = addYear(result, ref, false);
+		TeamOrPersonBase<?> team = ref.getAuthorTeam();
+		
+		if (team != null){
+			String teamTitle = CdmUtils.getPreferredNonEmptyString(team.getTitleCache(), team.getNomenclaturalTitle(), isAbbrev, true);
+			if (teamTitle.length() > 0 ){
+				result = team.getTitleCache() + afterAuthor + result;
+			}
+			
 		}
 		return result;
 	}
 	
+	protected abstract String getTitleWithoutYearAndAuthor(T reference, boolean isAbbrev);
+
+	
 	public String getCitation(T referenceBase) {
 		StringBuilder stringBuilder = new StringBuilder();
 		
@@ -95,12 +111,11 @@ public abstract class NomRefDefaultCacheStrategyBase<T extends Reference> extend
 			result = string + afterYear;
 		}else{
 			result = string + beforeYear + year + afterYear;
+			//TODO remove double dots (..) if string ends with "."?  #3645
 		}
 		return result;
 	}
 	
-	protected abstract String getNomRefTitleWithoutYearAndAuthor(T reference);
-	
 	public String getNomenclaturalCitation(T nomenclaturalReference, String microReference) {
 		if (nomenclaturalReference.isProtectedTitleCache()){
 			return nomenclaturalReference.getTitleCache();
@@ -113,4 +128,5 @@ public abstract class NomRefDefaultCacheStrategyBase<T extends Reference> extend
 		result = result.replaceAll(INomenclaturalReference.MICRO_REFERENCE_TOKEN, microReference);
 		return result;
 	}
+
 }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/ReferenceDefaultCacheStrategy.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/ReferenceDefaultCacheStrategy.java
new file mode 100644
index 0000000000..536eda8018
--- /dev/null
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/ReferenceDefaultCacheStrategy.java
@@ -0,0 +1,140 @@
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.strategy.cache.reference;
+
+import java.util.UUID;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
+import eu.etaxonomy.cdm.model.reference.Reference;
+import eu.etaxonomy.cdm.strategy.StrategyBase;
+/**
+ * @author a.mueller
+ * @created 08-Aug-2008 22:06:45
+ */
+public class ReferenceDefaultCacheStrategy<T extends Reference> extends StrategyBase implements IReferenceBaseCacheStrategy<T> {
+	@SuppressWarnings("unused")
+	private static final Logger logger = Logger.getLogger(ReferenceDefaultCacheStrategy.class);
+	
+	/**
+	 * Constructor
+	 */
+	public ReferenceDefaultCacheStrategy(){
+		super();
+	}
+	public static ReferenceDefaultCacheStrategy NewInstance(){
+		return new ReferenceDefaultCacheStrategy();
+	}
+	
+	
+	
+	protected String beforeYear = ". ";
+	protected String afterYear = "";
+	protected String afterAuthor = ", ";
+
+	private String blank = " ";
+	private String comma = ",";
+	private String dot =".";
+	
+	final static UUID uuid = UUID.fromString("763fe4a0-c79f-4f14-9693-631680225ec3");
+	
+
+	@Override
+	public String getAbbrevTitleCache(T reference) {
+		return getTitleCache(reference, true);
+	}
+
+	@Override
+	public String getTitleCache(T strictReferenceBase) {
+		return getTitleCache(strictReferenceBase, false);
+	}
+	
+	private String getTitleCache(T ref, boolean isAbbrev) {
+		String result = "";
+		if (ref == null){
+			return null;
+		}
+		String titel = CdmUtils.getPreferredNonEmptyString(ref.getTitle(), ref.getAbbrevTitle(), isAbbrev, true);
+		//titelAbbrev
+		String titelAbbrevPart = "";
+		if (isNotBlank(titel)){
+			result = titel + blank; 
+		}
+		//delete .
+		while (result.endsWith(".")){
+			result = result.substring(0, result.length()-1);
+		}
+		
+		result = addYear(result, ref);
+		TeamOrPersonBase<?> team = ref.getAuthorTeam();
+		if (team != null){
+			String author = CdmUtils.getPreferredNonEmptyString(team.getTitleCache(), team.getNomenclaturalTitle(), isAbbrev, true);
+			if (isNotBlank(author)){
+				result = author + afterAuthor + result;
+			}
+		}
+		return result;
+	}
+	
+	protected String addYear(String string, T ref){
+		String result;
+		if (string == null){
+			return null;
+		}
+		String year = CdmUtils.Nz(ref.getYear());
+		if ("".equals(year)){
+			result = string + afterYear;
+		}else{
+			result = string + beforeYear + year + afterYear;
+		}
+		return result;
+	}
+	
+	public String getCitation(T referenceBase) {
+		StringBuilder stringBuilder = new StringBuilder();
+		
+		TeamOrPersonBase<?> team = referenceBase.getAuthorTeam();
+		if (team != null &&  ! (team.getTitleCache() == null) && ! team.getTitleCache().trim().equals("")){
+			//String author = CdmUtils.Nz(team == null? "" : team.getTitleCache());
+			stringBuilder.append(team.getTitleCache() + afterAuthor);
+		}
+		
+		String year = CdmUtils.Nz(referenceBase.getYear());
+		if (!"".equals(year)){
+			stringBuilder.append(beforeYear + year);
+		}
+		
+		return stringBuilder.toString();
+	}
+
+
+
+	@Override
+	protected UUID getUuid() {
+		return UUID.fromString("919dbf70-33e7-11de-b418-0800200c9a66");
+	}
+	
+	
+	/**
+	 * 
+	 * @param referenceTitleCache
+	 * @param authorTitleCache
+	 * @return
+	 */
+	public static String putAuthorToEndOfString(String referenceTitleCache, String authorTitleCache) {
+		if(authorTitleCache != null){
+			referenceTitleCache = referenceTitleCache.replace(authorTitleCache + ", ", "");
+			referenceTitleCache += " - " + authorTitleCache;
+		}
+		return referenceTitleCache;
+	}
+
+}
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/ThesisDefaultCacheStrategy.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/ThesisDefaultCacheStrategy.java
index 6ec728092b..c61ca2ae4d 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/ThesisDefaultCacheStrategy.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/cache/reference/ThesisDefaultCacheStrategy.java
@@ -13,8 +13,6 @@ import java.util.UUID;
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
-//import eu.etaxonomy.cdm.model.reference.Generic;
-//import eu.etaxonomy.cdm.model.reference.Thesis;
 import eu.etaxonomy.cdm.model.reference.Reference;
 
 public class ThesisDefaultCacheStrategy <T extends Reference> extends NomRefDefaultCacheStrategyBase<T> implements  INomenclaturalReferenceCacheStrategy<T> {
@@ -53,25 +51,27 @@ public class ThesisDefaultCacheStrategy <T extends Reference> extends NomRefDefa
 	private ThesisDefaultCacheStrategy(){
 		super();
 	}
+
+
+	@Override
+	public String getAbbrevTitleCache(T thesis) {
+		return getTitleWithoutYearAndAuthor(thesis, true);
+	}
 	
 	@Override
-	protected String getNomRefTitleWithoutYearAndAuthor(T thesis){
+	protected String getTitleWithoutYearAndAuthor(T thesis, boolean isAbbrev){
 		//FIXME this is only a very fast copy and paste from "Generic". Must still be cleaned !
 		
 		if (thesis == null){
 			return null;
 		}
 		
+		//titelAbbrev
 		//TODO
-		String titelAbbrev = CdmUtils.Nz(thesis.getTitle()).trim();
-		
-		String nomRefCache = "";
+		String titelAbbrev = CdmUtils.getPreferredNonEmptyString(thesis.getTitle(), thesis.getAbbrevTitle(), isAbbrev, true);
 		
 		//titelAbbrev
-		if (!"".equals(titelAbbrev)){
-			nomRefCache = titelAbbrev + blank; 
-		}
-
+		String nomRefCache = titelAbbrev + blank;
 	
 		//delete .
 		while (nomRefCache.endsWith(".")){
@@ -81,4 +81,5 @@ public class ThesisDefaultCacheStrategy <T extends Reference> extends NomRefDefa
 		return nomRefCache.trim();
 	}
 
+
 }
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/generate/PolytomousKeyGenerator.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/generate/PolytomousKeyGenerator.java
index d24657c523..593f0af4e1 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/generate/PolytomousKeyGenerator.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/generate/PolytomousKeyGenerator.java
@@ -436,7 +436,7 @@ public class PolytomousKeyGenerator {
 	private Map<Set<TaxonDescription>,List<State>> determineCategoricalStates(List<State> statesDone, CategoricalData categoricalData, Feature feature, Set<TaxonDescription> taxaCovered){
 		Map<Set<TaxonDescription>,List<State>> childrenStatesMap = new HashMap<Set<TaxonDescription>,List<State>>();
 
-		List<StateData> stateDatas = categoricalData.getStates();
+		List<StateData> stateDatas = categoricalData.getStateData();
 
 		List<State> states = new ArrayList<State>();
 		for (StateData sd : stateDatas){
@@ -474,7 +474,7 @@ public class PolytomousKeyGenerator {
 			for (DescriptionElementBase deb : elements){
 				if (deb.isInstanceOf(CategoricalData.class)) {
 					if (deb.getFeature().equals(feature)) {
-						List<StateData> stateDatas = ((CategoricalData)deb).getStates();
+						List<StateData> stateDatas = ((CategoricalData)deb).getStateData();
 						for (StateData sd : stateDatas) {
 							if (sd.getState().equals(featureState)){
 								newCoveredTaxa.add(td);
@@ -535,7 +535,7 @@ public class PolytomousKeyGenerator {
 							if (deb.isInstanceOf(CategoricalData.class)) {
 								CategoricalData catdat = (CategoricalData)deb;
 								if (catdat.getFeature().equals(feature)) {
-									List<StateData> stateDatas = catdat.getStates();
+									List<StateData> stateDatas = catdat.getStateData();
 									for (StateData sd : stateDatas) {
 										differentStates.add(sd.getState());
 									}
@@ -794,8 +794,8 @@ public class PolytomousKeyGenerator {
 				iIdependencies.get(state).add(node.getFeature());
 			}
 		}
-		if (node.getChildren()!=null) {
-			for (FeatureNode fn : node.getChildren()){
+		if (node.getChildNodes()!=null) {
+			for (FeatureNode fn : node.getChildNodes()){
 				checkDependencies(fn);
 			}
 		}
@@ -838,12 +838,12 @@ public class PolytomousKeyGenerator {
 				{
 					CategoricalData cat1 = (CategoricalData)deb1;
 					CategoricalData cat2 = (CategoricalData)deb2;
-					for (StateData statedata1 : cat1.getStates()){
+					for (StateData statedata1 : cat1.getStateData()){
 						State state1 = statedata1.getState();
 						if (!exclusions.containsKey(state1)){
 							exclusions.put(state1, new HashSet<State>());
 						}
-						for (StateData statedata2 : cat2.getStates()){
+						for (StateData statedata2 : cat2.getStateData()){
 							State state2 = statedata2.getState();
 							if (!exclusions.containsKey(state2)){
 								exclusions.put(state2, new HashSet<State>());
@@ -886,8 +886,8 @@ public class PolytomousKeyGenerator {
 	 * @return
 	 */
 	private float defaultCategoricalPower(CategoricalData deb1, CategoricalData deb2){
-		List<StateData> states1 = deb1.getStates();
-		List<StateData> states2 = deb2.getStates();
+		List<StateData> states1 = deb1.getStateData();
+		List<StateData> states2 = deb2.getStateData();
 		boolean bool = false;
 		Iterator<StateData> stateData1Iterator = states1.iterator() ;
 		//		while (!bool && stateData1Iterator.hasNext()) {
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/match/DefaultMatchStrategy.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/match/DefaultMatchStrategy.java
index df046470d3..0016c7e7e4 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/match/DefaultMatchStrategy.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/match/DefaultMatchStrategy.java
@@ -28,6 +28,7 @@ import java.util.UUID;
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.common.DOI;
 import eu.etaxonomy.cdm.common.DoubleResult;
 import eu.etaxonomy.cdm.hibernate.HibernateProxyHelper;
 import eu.etaxonomy.cdm.model.common.CdmBase;
@@ -211,6 +212,8 @@ public class DefaultMatchStrategy extends StrategyBase implements IMatchStrategy
 					//result &= matchPrimitiveField(matchFirst, matchSecond, fieldMatcher, replaceModeList);
 				}else if(fieldType == URI.class){
 					result &= matchPrimitiveField(matchFirst, matchSecond, fieldMatcher, replaceModeList);
+				}else if(fieldType == DOI.class){
+					result &= matchPrimitiveField(matchFirst, matchSecond, fieldMatcher, replaceModeList);
 				}else if(isSingleCdmBaseObject(fieldType)){
 					result &= matchPrimitiveField(matchFirst, matchSecond, fieldMatcher, replaceModeList);
 				}else if (isCollection(fieldType)){
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImpl.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImpl.java
index 039a1c9b46..e07e215a4a 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImpl.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImpl.java
@@ -93,7 +93,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 	}
 	
 	public NonViralName getNonViralNameInstance(String fullString, NomenclaturalCode code, Rank rank){
-		NonViralName result = null;
+		NonViralName<?> result = null;
 		if(code ==null) {
 			boolean isBotanicalName = anyBotanicFullNamePattern.matcher(fullString).find();
 			boolean isZoologicalName = anyZooFullNamePattern.matcher(fullString).find();;
@@ -114,7 +114,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 			}
 		} else {
 			switch (code) {
-			case ICBN:
+			case ICNAFP:
 				result = BotanicalName.NewInstance(rank);
 				break;
 			case ICZN:
@@ -154,13 +154,13 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 		if (fullReferenceString == null){
 			return null;
 		}else{
-			NonViralName result = getNonViralNameInstance(fullReferenceString, nomCode, rank);
+			NonViralName<?> result = getNonViralNameInstance(fullReferenceString, nomCode, rank);
 			parseReferencedName(result, fullReferenceString, rank, MAKE_EMPTY);
 			return result;
 		}
 	}
 	
-	private String standardize(NonViralName nameToBeFilled, String fullReferenceString, boolean makeEmpty){
+	private String standardize(NonViralName<?> nameToBeFilled, String fullReferenceString, boolean makeEmpty){
 		//Check null and standardize
 		if (fullReferenceString == null){
 			//return null;
@@ -182,7 +182,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 	 * @param nameToBeFilled
 	 * @return
 	 */
-	private String getLocalFullName(NonViralName nameToBeFilled){
+	private String getLocalFullName(NonViralName<?> nameToBeFilled){
 		if (nameToBeFilled instanceof ZoologicalName){
 			return anyZooFullName;
 		}else if (nameToBeFilled instanceof BotanicalName) {
@@ -200,7 +200,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 	 * @param nameToBeFilled
 	 * @return
 	 */
-	private String getLocalSimpleName(NonViralName nameToBeFilled){
+	private String getLocalSimpleName(NonViralName<?> nameToBeFilled){
 		if (nameToBeFilled instanceof ZoologicalName){
 			return anyZooName;
 		}else if (nameToBeFilled instanceof NonViralName){
@@ -274,7 +274,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 		parsable.setProblemEnds(-1);
 	}
 	
-	private void makeNoFullRefMatch(NonViralName nameToBeFilled, String fullReferenceString, Rank rank){
+	private void makeNoFullRefMatch(NonViralName<?> nameToBeFilled, String fullReferenceString, Rank rank){
 	    //try to parse first part as name, but keep in mind full string is not parsable
 		int start = 0;
 		
@@ -308,7 +308,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 		logger.info("no applicable parsing rule could be found for \"" + fullReferenceString + "\"");    
 	}
 	
-	private void makeNameWithReference(NonViralName nameToBeFilled, 
+	private void makeNameWithReference(NonViralName<?> nameToBeFilled, 
 			String fullReferenceString, 
 			Matcher nameAndRefSeparatorMatcher,
 			Rank rank,
@@ -377,9 +377,9 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 	    	nameToBeFilled.addParsingProblems(ref.getParsingProblem());
 	    }
 	    
-	    Reference nomRef;
-		if ( (nomRef = (Reference)nameToBeFilled.getNomenclaturalReference()) != null ){
-			nomRef.setAuthorTeam((TeamOrPersonBase)nameToBeFilled.getCombinationAuthorTeam());
+	    Reference<?> nomRef;
+		if ( (nomRef = (Reference<?>)nameToBeFilled.getNomenclaturalReference()) != null ){
+			nomRef.setAuthorTeam((TeamOrPersonBase<?>)nameToBeFilled.getCombinationAuthorTeam());
 		}
 	}
 	
@@ -435,7 +435,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 	}
 	
 	
-	private void parseReference(NonViralName nameToBeFilled, String strReference, boolean isInReference){
+	private void parseReference(NonViralName<?> nameToBeFilled, String strReference, boolean isInReference){
 		
 		INomenclaturalReference ref;
 		String originalStrReference = strReference;
@@ -466,7 +466,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 				//continue
 			}else{
 				ref = makeDetailYearUnparsable(nameToBeFilled,strReference);
-				ref.setDatePublished(TimePeriod.parseString(yearPart));
+				ref.setDatePublished(TimePeriodParser.parseString(yearPart));
 				return;
 			}
 		}
@@ -610,7 +610,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 		if ("".equals(year.trim())){
 			return true;
 		}
-		TimePeriod datePublished = TimePeriod.parseString(year);
+		TimePeriod datePublished = TimePeriodParser.parseString(year);
 		
 		if (nomRef.getType().equals(ReferenceType.BookSection)){
 			handleBookSectionYear((IBookSection)nomRef, datePublished);
@@ -800,7 +800,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 				if ("[unranked]".equals(epi[1])){
 					infraGenericRank = Rank.INFRAGENERICTAXON();
 				}else{
-					infraGenericRank = Rank.getRankByAbbreviation(epi[1]);
+					infraGenericRank = Rank.getRankByIdInVoc(epi[1]);
 				}
 				nameToBeFilled.setRank(infraGenericRank);
 				nameToBeFilled.setGenusOrUninomial(epi[0]);
@@ -809,7 +809,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 			}
 			 //aggr. or group
 			 else if (aggrOrGroupPattern.matcher(fullNameString).matches()){
-				nameToBeFilled.setRank(Rank.getRankByAbbreviation(epi[2]));
+				nameToBeFilled.setRank(Rank.getRankByIdInVoc(epi[2]));
 				nameToBeFilled.setGenusOrUninomial(epi[0]);
 				nameToBeFilled.setSpecificEpithet(epi[1]);
 			}
@@ -822,7 +822,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 			}
 			 //autonym
 			 else if (autonymPattern.matcher(fullNameString).matches()){
-				nameToBeFilled.setRank(Rank.getRankByAbbreviation(epi[epi.length - 2]));
+				nameToBeFilled.setRank(Rank.getRankByIdInVoc(epi[epi.length - 2]));
 				nameToBeFilled.setGenusOrUninomial(epi[0]);
 				nameToBeFilled.setSpecificEpithet(epi[1]);
 				nameToBeFilled.setInfraSpecificEpithet(epi[epi.length - 1]);
@@ -842,7 +842,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 				if ("[unranked]".equals(infraSpecRankEpi)){
 					infraSpecificRank = Rank.INFRASPECIFICTAXON();
 				}else{
-					infraSpecificRank = Rank.getRankByAbbreviation(infraSpecRankEpi);
+					infraSpecificRank = Rank.getRankByIdInVoc(infraSpecRankEpi);
 				}
 				nameToBeFilled.setRank(infraSpecificRank);
 				nameToBeFilled.setGenusOrUninomial(epi[0]);
@@ -853,7 +853,7 @@ public class NonViralNameParserImpl extends NonViralNameParserImplRegExBase impl
 			 else if (oldInfraSpeciesPattern.matcher(fullNameString).matches()){
 				boolean implemented = false;
 				if (implemented){
-					nameToBeFilled.setRank(Rank.getRankByNameOrAbbreviation(epi[2]));
+					nameToBeFilled.setRank(Rank.getRankByNameOrIdInVoc(epi[2]));
 					nameToBeFilled.setGenusOrUninomial(epi[0]);
 					nameToBeFilled.setSpecificEpithet(epi[1]);
 					//TODO result.setUnnamedNamePhrase(epi[2] + " " + epi[3]);
diff --git a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplRegExBase.java b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplRegExBase.java
index f956235260..61e3b3d2e9 100644
--- a/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplRegExBase.java
+++ b/cdmlib-model/src/main/java/eu/etaxonomy/cdm/strategy/parser/NonViralNameParserImplRegExBase.java
@@ -13,6 +13,8 @@ import java.util.regex.Pattern;
 
 import org.apache.log4j.Logger;
 
+import eu.etaxonomy.cdm.common.UTF8;
+
 
 /**
  * This class is a base class that separates regex parts of the parser from methods
@@ -29,7 +31,7 @@ public abstract class NonViralNameParserImplRegExBase  {
     protected static String epiSplitter = "(\\s+|\\(|\\))"; //( ' '+| '(' | ')' )
     protected static Pattern pattern = Pattern.compile(epiSplitter); 
 
-	public static final String hybridSign = "\u00D7";
+	public static final String hybridSign = UTF8.HYBRID.toString();  //  "\u00D7";
 
     //some useful non-terminals
     protected static String pStart = "^";
